//
//  MainTabBarController.m
//  TableBar6.27
//
//  Created by Administrator on 16/6/27.
//  Copyright © 2016年 glanway. All rights reserved.
//

#import "MainTabBarController.h"
#import "MainTabBar.h"
#import "MainNavigationController.h"
#import "AddressBookViewController.h"
#import "DialogueViewController.h"
#import "MailViewController.h"
#import "MoreViewController.h"
#import "TaskViewController.h"

@interface MainTabBarController ()<MainTabBarDelegate>
@property(nonatomic, weak)MainTabBar *mainTabBar;
@property(nonatomic, strong)AddressBookViewController *addressVc;
@property(nonatomic, strong)DialogueViewController *dialogueVc;
@property(nonatomic, strong)MailViewController *mailVc;
@property(nonatomic, strong)MoreViewController *moreVc;
@property(nonatomic, strong)TaskViewController *taskVc;



@end

@implementation MainTabBarController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self SetupMainTabBar];
    [self SetupAllControllers];

}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)SetupMainTabBar{
    MainTabBar *mainTabBar = [[MainTabBar alloc]init];
    mainTabBar.frame = self.tabBar.bounds;
    mainTabBar.delegate = self;
    [self.tabBar addSubview:mainTabBar];
    _mainTabBar =mainTabBar;
}

-(void)SetupAllControllers{
    NSArray *title = @[@"任务",@"会话",@"邮件",@"通讯录",@"更多"];
    NSArray *images =@[@"foot_icon01",@"foot_icon02",@"foot_icon03",@"foot_icon04",@"foot_icon05"];
    NSArray *selectedImages=@[@"foot_icon01On",@"foot_icon02On",@"foot_icon03On",@"foot_icon04On",@"foot_icon05On"];
    
    self.addressVc = [[AddressBookViewController alloc]init];
    self.dialogueVc = [[DialogueViewController alloc]init];
    self.mailVc = [[MailViewController alloc]init];
    self.taskVc = [[TaskViewController alloc]init];
    self.moreVc = [[MoreViewController alloc]init];
    
    NSArray *viewControllers = @[self.taskVc,self.dialogueVc,self.mailVc,self.addressVc,self.moreVc];
    
    for (int i = 0; i<viewControllers.count; i++) {
        UIViewController *childVc = viewControllers[i];
        MainNavigationController *nav = [[MainNavigationController alloc] initWithRootViewController:childVc];
        childVc.tabBarItem.image = [UIImage imageNamed:images[i]];
        childVc.tabBarItem.selectedImage = [UIImage imageNamed:selectedImages[i]];
        childVc.tabBarItem.title = title[i];
        [self.mainTabBar addTabBarButtonWithTabBarItem:childVc.tabBarItem];
        [self addChildViewController:nav];
    }
}



- (void)tabBar:(MainTabBar *)tabBar didSelectButtonFrom:(long)fromBtnTag to:(long)toBtnTag{
     self.selectedIndex = toBtnTag;
}




@end
