//
//  TaskViewController.m
//  自定义TabelBar
//
//  Created by admin on 16/6/26.
//  Copyright © 2016年 admin. All rights reserved.
//

#import "TaskViewController.h"

#define SCREEN_WIDTH ([UIScreen mainScreen].bounds.size.width)
#define SCREEN_HEIGHT ([UIScreen mainScreen].bounds.size.height)

#define IOS_VERSION [[[UIDevice currentDevice] systemVersion] floatValue]

//根据屏幕转化的对应值
#define TRANS_VALUE(x) ceil(SCREEN_WIDTH * x / 320)

#define CONVER_VALUE(x) ceil(SCREEN_WIDTH * x / 375)

// rgb颜色转换（16进制->10进制）
#define UIColorFromRGB(rgbValue) [UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:1.0]

#define RGBCOLOR(r,g,b) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:1.0]

#define RGBACOLOR(r,g,b,a) [UIColor colorWithRed:(r)/255.0 green:(g)/255.0 blue:(b)/255.0 alpha:(a)]

//中文字体：微软雅黑
//英文、数字：arial
//黑色文字：#2C3031
//灰色文字：#AEAEAE
//绿色文字：#12BE4F
//页面背景颜色：#F5F5F5
//分割线、边框线：#CBCBCB

//#define I_COLOR_YELLOW    RGBACOLOR(237, 131, 47, 1.0f)      //黄色
//#define I_COLOR_YELLOW    UIColorFromRGB(0xEE822F)      //黄色
#define I_COLOR_YELLOW    UIColorFromRGB(0xf0821e)
#define I_COLOR_WHITE     RGBACOLOR(255, 255, 255, 1.0f)     //白色
#define I_COLOR_BLACK     RGBACOLOR(20, 20, 20, 1.0f)        //黑色
#define I_COLOR_EDITTEXT  UIColorFromRGB(0xf4f8f9)            //浅黑色
#define I_COLOR_33BLACK  UIColorFromRGB(0x333333)            //浅黑色
#define I_COLOR_DARKGRAY  UIColorFromRGB(0x858585)           //深灰色
#define I_COLOR_GRAY      UIColorFromRGB(0x999999)           //灰色
#define I_COLOR_DARKGREEN RGBACOLOR(134, 203, 201, 1.0f)     //青绿色
#define I_BACKGROUND_COLOR  RGBACOLOR(240, 240, 240, 1.0f)   //背景颜色
#define I_DIVIDER_COLOR  RGBACOLOR(231, 231, 231, 1.0f)      //分割条颜色
#define I_TAB_BACKGROUND_COLOR  RGBACOLOR(240, 240, 240, 1.0f) //灰白色
#define I_NEW_BACKGROUND_COLOR  RGBACOLOR(200, 204, 210, 1.0f) //键盘色

//#define IH_COLOR_GREEN    UIColorFromRGB(0x12BE4F)           //绿色
#define IH_COLOR_ORANGE   RGBACOLOR(252, 102, 34, 1.0f)      //橙色
#define TEXT_COLOR_BLACK  UIColorFromRGB(0xF8B62C)           //黑色文字
#define TEXT_COLOR_GRAY   UIColorFromRGB(0xAEAEAE)           //灰色文字
#define TEXT_COLOR_GREEN  UIColorFromRGB(0x12BE4F)           //绿色文字
#define BACKGROUND_COLOR  UIColorFromRGB(0xFFFFFF)           //页面背景颜色
#define DIVIDER_COLOR     UIColorFromRGB(0xCBCBCB)           //分割线颜色
#define BORDER_COLOR      UIColorFromRGB(0xCBCBCB)           //边框线颜色

@interface TaskViewController ()<UITextViewDelegate>
@property (nonatomic, strong)UITextView *showTextView;
@end

@implementation TaskViewController

- (void)viewDidLoad {
    [super viewDidLoad];
     self.view.backgroundColor = [UIColor whiteColor];
    self.title = @"富文本展示";
    self.showTextView = [[UITextView alloc]initWithFrame:CGRectMake(10, 150,SCREEN_WIDTH-20 , 300)];
    [self.view addSubview:self.showTextView];
    self.showTextView.text = @"这里是富文本的显示效果";
    self.showTextView.userInteractionEnabled = NO; 
    self.showTextView.editable = NO;
// 字体的大小，字体的颜色 ，背景颜色
     [self showType1];
// 连体字
//    [self showType2];
// 字符之间的间距
//    [self showType3];
// 带删除线的
//    [self showType4];
// 下划线
//    [self showType5];
// 空心字体
//    [self showType6];
// 文字阴影
//    [self showType7];
// 文字的基线偏移
//    [self showType8];
// 文字的倾斜
//    [self showType9];
// 倒序
//    [self showType10];
// 超链接
//    [self showType11];
// 图文混排
//    [self showType12];
    

}

- (void)showType1{

//1.设置字体的大小                NSFontAttributeName
//2.设置字体的颜色               NSForegroundColorAttributeName
//3.设置字体的背景颜色.          NSBackgroundColorAttributeName
    NSString *string = @"落霞与孤鹜齐飞,秋水共长天一色sdasdasdaplskfplsadmvkasmvlams;dokvams;kldcnams;dklnfl;ksdnflk;asnfmdklasdmf;kl";
    NSMutableAttributedString *mutableAttriteStr = [[NSMutableAttributedString alloc] init];
    NSAttributedString *attributeStr1 = [[NSAttributedString alloc] initWithString:[string substringWithRange:NSMakeRange(0, 3)] attributes:@{NSFontAttributeName :[UIFont fontWithName:@"futura" size:12],NSForegroundColorAttributeName : [UIColor redColor],NSBackgroundColorAttributeName : [UIColor yellowColor]}];
    NSAttributedString *attributeStr4 = [[NSAttributedString alloc] initWithString:[string substringWithRange:NSMakeRange(3, 4)] attributes:@{NSFontAttributeName :[UIFont fontWithName:@"futura" size:22],NSForegroundColorAttributeName : [UIColor redColor],NSBackgroundColorAttributeName : [UIColor yellowColor]}];
    NSAttributedString *attributeStr2 = [[NSAttributedString alloc] initWithString:[string substringWithRange:NSMakeRange(8, 4)] attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:22],NSForegroundColorAttributeName : [UIColor blackColor],NSBackgroundColorAttributeName : [UIColor lightGrayColor]}];
    NSAttributedString *attributeStr5 = [[NSAttributedString alloc] initWithString:[string substringWithRange:NSMakeRange(12, string.length-12)] attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:12],NSForegroundColorAttributeName : [UIColor blackColor],NSBackgroundColorAttributeName : [UIColor lightGrayColor]}];
    NSAttributedString *attriteStr3 = [[NSAttributedString alloc] initWithString:[string substringWithRange:NSMakeRange(7, 1)] attributes:@{NSBackgroundColorAttributeName : [UIColor greenColor]}];
    [mutableAttriteStr appendAttributedString:attributeStr1];
    [mutableAttriteStr appendAttributedString:attributeStr4];
    [mutableAttriteStr appendAttributedString:attriteStr3];
    [mutableAttriteStr appendAttributedString:attributeStr2];
    [mutableAttriteStr appendAttributedString:attributeStr5];
    self.showTextView.attributedText = mutableAttriteStr;

}

- (void)showType2{
    //连体字           NSLigatureAttributeName
    
    self.showTextView.attributedText = [[NSAttributedString alloc] initWithString:@"flush and fily   Gglfimg" attributes:@{NSLigatureAttributeName : [NSNumber numberWithInt:1],NSFontAttributeName : [UIFont fontWithName:@"futura" size:30]}];
    
    
}

- (void)showType3{
    //字间距          NSKernAttributeName
    
    NSMutableAttributedString *mutableAttributeStr2 = [[NSMutableAttributedString alloc] init];
    NSAttributedString *string6 = [[NSAttributedString alloc] initWithString:@"ABCDE " attributes:@{NSKernAttributeName : [NSNumber numberWithInt:-3],NSForegroundColorAttributeName : [UIColor redColor]}];
    NSAttributedString *string7 = [[NSAttributedString alloc] initWithString:@"FGHIJ " attributes:@{NSKernAttributeName : [NSNumber numberWithInt:0],NSForegroundColorAttributeName : [UIColor yellowColor]}];
    NSAttributedString *string8 = [[NSAttributedString alloc] initWithString:@"KLMNO " attributes:@{NSKernAttributeName : @(25),NSForegroundColorAttributeName : [UIColor blueColor]}];
    [mutableAttributeStr2 appendAttributedString:string6];
    [mutableAttributeStr2 appendAttributedString:string7];
    [mutableAttributeStr2 appendAttributedString:string8];
    self.showTextView.attributedText = mutableAttributeStr2;

    
    
}
- (void)showType4{
    NSMutableAttributedString *mutableAttributeStr3 = [[NSMutableAttributedString alloc] init];
    NSMutableAttributedString *string9 = [[NSMutableAttributedString alloc] initWithString:@"只要998  " attributes:@{NSStrikethroughStyleAttributeName : @(NSUnderlineStyleSingle),NSStrikethroughColorAttributeName : [UIColor redColor]}];
    [string9 addAttribute:NSFontAttributeName value:[UIFont systemFontOfSize:TRANS_VALUE(14.0f)] range:NSMakeRange(0, string9.length)];
    NSMutableAttributedString *string10 = [[NSMutableAttributedString alloc] initWithString:@"真的998  " attributes:@{NSStrikethroughStyleAttributeName : @(NSUnderlineStyleThick),NSStrikethroughColorAttributeName : [UIColor blueColor]}];
    [string10 addAttribute:NSForegroundColorAttributeName value:[UIColor redColor] range:NSMakeRange(0, 3)];
    NSMutableAttributedString *string11 = [[NSMutableAttributedString alloc] initWithString:@"好吧9块拿走" attributes:@{NSStrikethroughStyleAttributeName : @(NSUnderlineStyleDouble),NSStrikethroughColorAttributeName : [UIColor yellowColor],NSBackgroundColorAttributeName:[UIColor greenColor]}];
    [string11 addAttribute:NSBackgroundColorAttributeName value:[UIColor yellowColor] range:NSMakeRange(3, string11.length-3)];
    
    [mutableAttributeStr3 appendAttributedString:string9];
    [mutableAttributeStr3 appendAttributedString:string10];
    [mutableAttributeStr3 appendAttributedString:string11];
    self.showTextView.attributedText = mutableAttributeStr3;
    
    
    
}
- (void)showType5{
    
    NSMutableAttributedString *mutableAttributeStr4 = [[NSMutableAttributedString alloc] init];
    NSAttributedString *string12 = [[NSAttributedString alloc] initWithString:@"只要888  " attributes:@{NSUnderlineStyleAttributeName : @(NSUnderlineStyleSingle),NSUnderlineColorAttributeName : [UIColor redColor]}];
    NSAttributedString *string13 = [[NSAttributedString alloc] initWithString:@"真的88  " attributes:@{NSUnderlineStyleAttributeName : @(NSUnderlineStyleThick),NSUnderlineColorAttributeName : [UIColor purpleColor]}];
    NSAttributedString *string14 = [[NSAttributedString alloc] initWithString:@"好吧8块拿走" attributes:@{NSUnderlineStyleAttributeName : @(NSUnderlineStyleDouble),NSUnderlineColorAttributeName : [UIColor yellowColor]}];
    
    [mutableAttributeStr4 appendAttributedString:string12];
    [mutableAttributeStr4 appendAttributedString:string13];
    [mutableAttributeStr4 appendAttributedString:string14];
    self.showTextView.attributedText = mutableAttributeStr4;
    
    
}
- (void)showType6{
    
    NSMutableAttributedString *mutableAttributeStr5 = [[NSMutableAttributedString alloc] init];
    // 如果这个stroke的width正数的时候，字体就中空了，那么前景色就设置无效了
    NSAttributedString *string15 = [[NSAttributedString alloc] initWithString:@"HELLO " attributes:@{NSStrokeWidthAttributeName : @(5),NSStrokeColorAttributeName : [UIColor yellowColor],NSFontAttributeName : [UIFont boldSystemFontOfSize:30],NSForegroundColorAttributeName : [UIColor redColor]}];
    NSAttributedString *string16 = [[NSAttributedString alloc] initWithString:@"YUKD  " attributes:@{NSStrokeWidthAttributeName : @(0),NSStrokeColorAttributeName : [UIColor redColor],NSFontAttributeName : [UIFont boldSystemFontOfSize:30]}];
    NSAttributedString *string17 = [[NSAttributedString alloc] initWithString:@"GOOGLE" attributes:@{NSStrokeWidthAttributeName : @(-5),NSStrokeColorAttributeName : [UIColor greenColor],NSFontAttributeName : [UIFont boldSystemFontOfSize:30],NSForegroundColorAttributeName : [UIColor lightGrayColor]}];
    
    [mutableAttributeStr5 appendAttributedString:string15];
    [mutableAttributeStr5 appendAttributedString:string16];
    [mutableAttributeStr5 appendAttributedString:string17];
    self.showTextView.attributedText = mutableAttributeStr5;
    
    
    
    
}
- (void)showType7{
    // 设置阴影
    NSShadow *shadow = [[NSShadow alloc] init];
    shadow.shadowBlurRadius = 5.0f; // 模糊度
    shadow.shadowColor = [UIColor blueColor];
    shadow.shadowOffset = CGSizeMake(1, 5);
    NSAttributedString *string20 = [[NSAttributedString alloc] initWithString:@"HELLO_HALY_璟" attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:30],NSForegroundColorAttributeName : [UIColor redColor],NSShadowAttributeName : shadow}];
    
    self.showTextView.attributedText = string20;
    
    
    
}
- (void)showType8{
    NSShadow *shadow = [[NSShadow alloc] init];
    shadow.shadowBlurRadius = 5.0f; // 模糊度
    shadow.shadowColor = [UIColor blueColor];
    shadow.shadowOffset = CGSizeMake(1, 5);
    
    // 设置文本的基线 负数向下  正数向上  0不变
    UIFont *bigFont = [UIFont boldSystemFontOfSize:36];
    UIFont *smallFont = [UIFont boldSystemFontOfSize:bigFont.pointSize / 2];
    CGFloat capHeight = bigFont.pointSize - smallFont.pointSize;
    NSMutableAttributedString *attributeString6 = [[NSMutableAttributedString alloc] init];
    NSAttributedString *string22 = [[NSAttributedString alloc] initWithString:@"￥" attributes:@{NSFontAttributeName : smallFont,NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(0)}];
    NSAttributedString *string23 = [[NSAttributedString alloc] initWithString:@"9" attributes:@{NSFontAttributeName : bigFont,NSForegroundColorAttributeName : [UIColor blueColor],NSBaselineOffsetAttributeName : @(0)}];
    NSAttributedString *string24 = [[NSAttributedString alloc] initWithString:@".99" attributes:@{NSFontAttributeName : smallFont,NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(0)}];
    
    
    NSAttributedString *string28 = [[NSAttributedString alloc] initWithString:@"    七夕大促销    " attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:24],NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(0),NSShadowAttributeName : shadow}];
    
    NSAttributedString *string25 = [[NSAttributedString alloc] initWithString:@"￥" attributes:@{NSFontAttributeName : smallFont,NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(capHeight - 5)}];
    NSAttributedString *string26 = [[NSAttributedString alloc] initWithString:@"0" attributes:@{NSFontAttributeName : bigFont,NSForegroundColorAttributeName : [UIColor redColor],NSBaselineOffsetAttributeName : @(0)}];
    NSAttributedString *string27 = [[NSAttributedString alloc] initWithString:@".09" attributes:@{NSFontAttributeName : smallFont,NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(capHeight - 5)}];
    [attributeString6 appendAttributedString:string22];
    [attributeString6 appendAttributedString:string23];
    [attributeString6 appendAttributedString:string24];
    [attributeString6 appendAttributedString:string28];
    [attributeString6 appendAttributedString:string25];
    [attributeString6 appendAttributedString:string26];
    [attributeString6 appendAttributedString:string27];
    self.showTextView.attributedText = attributeString6;
//    
//    NSMutableAttributedString *attributeString7 = [[NSMutableAttributedString alloc] init];
//    
//    NSAttributedString *string29 = [[NSAttributedString alloc] initWithString:@"Hello  " attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:40],NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(0)}];
//    NSAttributedString *string30 = [[NSAttributedString alloc] initWithString:@"  World    " attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:20],NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(0)}];
//    
//    NSAttributedString *string31 = [[NSAttributedString alloc] initWithString:@"Hello  " attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:40],NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(0)}];
//    NSAttributedString *string32 = [[NSAttributedString alloc] initWithString:@"  World" attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:20],NSForegroundColorAttributeName : [UIColor blackColor],NSBaselineOffsetAttributeName : @(6)}];
//    
//    
//    [attributeString7 appendAttributedString:string29];
//    [attributeString7 appendAttributedString:string30];
//    [attributeString7 appendAttributedString:string31];
//    [attributeString7 appendAttributedString:string32];
//    self.showTextView.attributedText = attributeString7;
    
    
}
- (void)showType9{
    NSShadow *shadow = [[NSShadow alloc] init];
    shadow.shadowBlurRadius = 5.0f; // 模糊度
    shadow.shadowColor = [UIColor blueColor];
    shadow.shadowOffset = CGSizeMake(1, 5);

    //    说明：NSVerticalGlyphFormAttributeName 设置文字排版方向，取值为NSNumber对象（整数），0表示横排文本，1表示竖排文本 在iOS中只支持0
    //说明：NSObliquenessAttributeName 设置字体倾斜度，取值为 NSNumber（float），正值右倾，负值左倾
    //    NSExpansionAttributeName
    //    说明：NSExpansionAttributeName 设置字体的横向拉伸，取值为NSNumber （float），正值拉伸 ，负值压缩
    NSMutableAttributedString *mutableAttriteStr = [[NSMutableAttributedString alloc] init];
    NSAttributedString *attributeStr1 = [[NSAttributedString alloc] initWithString:@"HeHe_XiXi_mm" attributes:@{NSFontAttributeName :[UIFont boldSystemFontOfSize:30],NSForegroundColorAttributeName : [UIColor redColor],NSShadowAttributeName : shadow,NSObliquenessAttributeName : @(1),NSExpansionAttributeName : @(1),NSVerticalGlyphFormAttributeName : @(1)}];
    [mutableAttriteStr appendAttributedString:attributeStr1];
    self.showTextView.attributedText = mutableAttriteStr;
    
    
}
- (void)showType10{
    
    // 文字书写方向
    //    The values of the NSNumber objects should be 0, 1, 2, or 3, for LRE, RLE, LRO, or RLO respectively, and combinations of leftToRight and rightToLeft with NSTextWritingDirectionEmbedding or NSTextWritingDirectionOverride, as shown in Table 1.
    //    NSWritingDirectionLeftToRight | NSTextWritingDirectionEmbedding
    //    NSWritingDirectionRightToLeft | NSTextWritingDirectionEmbedding
    //    NSWritingDirectionLeftToRight | NSTextWritingDirectionOverride
    //    NSWritingDirectionRightToLeft | NSTextWritingDirectionOverride
    NSMutableAttributedString *attributuStr2 = [[NSMutableAttributedString alloc] init];
    NSAttributedString *string1 = [[NSAttributedString alloc] initWithString:@"一切皆有可能" attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:24],NSForegroundColorAttributeName : [UIColor redColor],NSWritingDirectionAttributeName : @[@(3)]}];
    [attributuStr2 appendAttributedString:string1];
    self.showTextView.attributedText = attributuStr2;
    
    
}
- (void)showType11{
    
    //    把 NSLinkAttributeName 属性单独列出来，是因为在 UILabel 和 UITextField 中是无法使用该属性的。更准确点说是在UILabel 和 UITextField 中无法实现点击链接启动浏览器打开一个URL地址，因为在此过程中用到了一个代理函数。只能用在 UITextView 中
    self.showTextView.delegate = self;
    self.showTextView.scrollEnabled = NO;
    self.showTextView.textContainer.lineFragmentPadding = 0;
    self.showTextView.textContainerInset = UIEdgeInsetsMake(0, 0, 0, 0);
    NSString *str = @"  跳转到百度";
    NSMutableAttributedString *attrStr = [[NSMutableAttributedString alloc]initWithString:str];
    [attrStr addAttribute:NSLinkAttributeName value:[NSURL URLWithString:@"http://www.baidu.com"] range:[str rangeOfString:@"百度"]];
    [attrStr addAttribute:NSFontAttributeName value:[UIFont boldSystemFontOfSize:30] range:NSMakeRange(0, str.length)];
    self.showTextView.attributedText = attrStr;
    
//    
}
- (void)showType12{
    
    NSString *words = @"天才";
    NSMutableAttributedString *strAtt = [[NSMutableAttributedString alloc] initWithString:words attributes:@{NSFontAttributeName : [UIFont boldSystemFontOfSize:25]}];
    NSTextAttachment *attatch = [[NSTextAttachment alloc] initWithData:nil ofType:nil];
    attatch.bounds = CGRectMake(0,-10, 50, 50);
    attatch.image = [UIImage imageNamed:@"1.jpg"];
    NSTextAttachment *attatch1 = [[NSTextAttachment alloc] initWithData:nil ofType:nil];
    attatch1.bounds = CGRectMake(0, -10, 50, 50);
    attatch1.image = [UIImage imageNamed:@"2.jpg"];
    NSAttributedString *string8 = [NSAttributedString attributedStringWithAttachment:attatch];
    NSAttributedString *string9 = [NSAttributedString attributedStringWithAttachment:attatch1];
    [strAtt insertAttributedString:string8 atIndex:1];
    [strAtt insertAttributedString:string9 atIndex:0];
    self.showTextView.attributedText = strAtt;
    
    
}



- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
